module DKIDE.Parse (
	removeBlank,
	removeBlanks,
	removeTab,
	removeTabs,
	removeTabAndBlank,
	removeTabsAndBlanks,
	blankSlice,
	strSlice,
	removeDotType,
	getDotType,
	nameFromPath,
	purePath,
	search,
	dropTo,
	takeTo
) where

import Data.List as L

removeBlank :: String -> String
removeBlank [] = []
removeBlank (s:str) =
	if s == ' ' 
	then removeBlank str 
	else s:str
		  
removeBlanks :: String -> String 
removeBlanks =
	L.reverse.removeBlank.L.reverse.removeBlank
	
removeTab :: String -> String
removeTab [] = []
removeTab (s:str) =
	if s == '\t'
	then removeTab str
	else s : str

removeTabs :: String -> String
removeTabs =
	L.reverse.removeTab.L.reverse.removeTab 

removeTabAndBlank :: String -> String
removeTabAndBlank [] = []
removeTabAndBlank (s:str) =
	if s == ' ' || s == '\t'
	then removeTabAndBlank str
	else s : str
	
removeTabsAndBlanks :: String -> String
removeTabsAndBlanks =
	L.reverse.removeTabAndBlank.L.reverse.removeTabAndBlank	

blankSlice :: String -> [String]
blankSlice [] = []
blankSlice str =
		L.takeWhile (/=' ') str : blankSlice (if L.length rest == 0 then [] else L.tail rest)
	where 
		rest =
			 L.dropWhile (/=' ') str

strSlice :: [String] -> String -> [String]
strSlice _ [] = []
strSlice substr str =
	 	if search "#!@#" str 
	 	then error ("ERROR: strSlice nalezla invalidní sadu charakterů #!@# ve zpracovávaném řetězci: " ++ str)
	 	else L.init (exec str)
	where
		contain [] _ = []
		contain (s:ss) str' =
			if L.take (L.length s) str' == s
			then s
			else contain ss str'
		exec [] = []
		exec str' =
				firstHalf : secondHalf : exec (L.drop (L.length firstHalf + L.length secondHalf) str')
			where
				part [] = []
				part str''@(s:ss) =
					if contain substr str'' == []
					then s : part ss
					else "#!@#" ++ contain substr str''
				(firstHalf, secondHalf) =
					(takeTo "#!@#" (part str'), dropTo "#!@#" (part str'))
		
removeDotType :: String -> String
removeDotType path =
	L.takeWhile (/='.') path

getDotType :: String -> String
getDotType str =
	L.reverse (L.takeWhile (/='.') (L.reverse str))

nameFromPath :: String -> String
nameFromPath [] = []
nameFromPath path =
	L.reverse.L.takeWhile (/='/').L.reverse $ path

purePath :: String -> String
purePath [] = []
purePath path = 
	L.init (L.reverse.L.dropWhile (/='/').L.reverse $ path)

search :: String -> String -> Bool
search [] [] = True
search _ [] = False
search [] _ = False
search substr str =
	if L.take (L.length substr) str == substr
	then True
	else search substr (L.tail str)

dropTo :: String -> String -> String
dropTo _ [] = []
dropTo sub str =
	if L.take (L.length sub) str == sub
	then L.drop (L.length sub) str
	else dropTo sub (L.tail str)
	
takeTo :: String -> String -> String
takeTo _ [] = []
takeTo sub str =
	if L.take (L.length sub) str == sub
	then []
	else L.head str : takeTo sub (L.tail str)
