module Rose.StrTape (
	StrTape,
	initSTape,
	headSTape,
	writeHeadSTape,
	writeSTape,
	shiftToBeginSTape,
	shiftBackSTape,
	shiftForwardSTape,
	submitSTape,
	getSTape
) where

import Prelude
import Data.List as L
import Data.IORef

data StrTape = StrTape [String] String [String] deriving (Eq,Show,Read)

initSTape = 
	StrTape [] "" []
headSTape (StrTape _ h _) = h
writeHeadSTape s (StrTape l _ r) = 
	StrTape l s r 
writeSTape s t@(StrTape l h r) = 
	case 
		if s == [] 
		then t 
		else if r == []
		then if h == [] then StrTape (s : l) [] [] else StrTape (s : h : l) [] [] 
		else case shiftToBeginSTape t of 
			(StrTape l' h' r') -> 
				if h' == [] 
				then StrTape (s : l') [] [] 
				else StrTape (s : h' : l') [] [] of
		(StrTape l h r) -> StrTape (L.filter (/=" <> ") l) h r 
shiftToBeginSTape t@(StrTape l h []) = t
shiftToBeginSTape (StrTape l h (r':r)) = 
	shiftToBeginSTape (StrTape (h : l) r' r)
shiftBackSTape t@(StrTape [] h r) = t
shiftBackSTape (StrTape (l':l) [] r) = 
	StrTape l l' r 
shiftBackSTape (StrTape (l':l) h r) = 
	StrTape l l' (h : r)  
shiftForwardSTape t@(StrTape l [] []) = t
shiftForwardSTape (StrTape l h []) = 
	StrTape (h : l) [] []
shiftForwardSTape (StrTape l [] (r':r)) = 
	StrTape l r' r  
shiftForwardSTape (StrTape l h (r':r)) = 
	StrTape (h : l) r' r
submitSTape fun t = 
	modifyIORef t fun
getSTape fun t = do
	tape <- readIORef t
	return (fun tape)
