.intel_syntax noprefix
.code16
.text

.macro initStack segm , off
mov ax , \segm
mov ss , ax
mov sp , offset \off
.endm

.macro setSegments num
mov ax , \num
mov ds , ax
mov es , ax
mov fs , ax
mov gs , ax
.endm

.macro initBootloaderEnviroment
initStack 1000 , 15743
setSegments 0x7c0		
.endm

.globl entryPoint
entryPoint:
	initBootloaderEnviroment
	mov ax , offset message
	call printString
	hlt
	inf: jmp inf

.globl printString
printString:
		mov si , ax
	printStrLoop:
		mov al , byte ptr [si]
		cmp al , 0
		je ps0
		call printChar
		inc si
		jmp printStrLoop
	ps0:
		ret

.globl printChar 
printChar:
	push ax
	mov bl , 0xf
	call setCharColor
	pop ax  
	mov ah , 0xe
	int 0x10
	ret

.globl setCharColor
setCharColor:
	mov ah , 0x9
	mov al , ' '
	mov bh , 0
	mov cx , 1
	int 0x10
	ret

.data
message: .string "Hello world from low level! :)" 	
.att_syntax noprefix